module Clerk
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
    establish_connection Clerk.database_connection_url
    def self.clerk_table_name(table_name)
      # version = Clerk::VERSION.split(".").map.with_index{|x, i| (i==2 ? "00" : x.rjust(2, '0')) }.join
      "#{table_name}_01"
    end

    def self.clerk_table_name_nc(table_name)
      version = Clerk::VERSION.split(".").map{|x| x.rjust(2, '0')}.join
      "#{table_name}_#{version}_#{Clerk.key_secret}"
    end

    def self.transaction(options = {}, &block)
      # were overriding all the methods that need transactions
      # these interfere with pgbouncer.  just yield the block
      yield
    rescue ActiveRecord::Rollback
      # rollbacks are silently swallowed
    end        
  end
end
