module Clerk
  class Email < Clerk::ApplicationRecord
    self.table_name = self.clerk_table_name("emails")
    self.primary_key = 'id'

    def self.clerk_persistence_path
      "/api/emails"
    end
 
    def self.clerk_persistence_api
      @@conn ||= Clerk::Api::Connection.new(
        (ENV["CLERK_API_PATH"] || "https://accounts.clerk.dev"),
        Clerk.key_secret
      )
    end    
  end
end
