module Clerk
  class SessionToken < Clerk::ApplicationRecord
    self.table_name = self.clerk_table_name("session_tokens")
    self.primary_key = 'id'

    belongs_to :account, class_name: "Clerk::Account"

    def self.find_account(cookie:)
      require "bcrypt"
      begin
        id, token, token_hash = Clerk.decrypt(cookie).split("--")
        if BCrypt::Password.new(token_hash) == token
          Account.joins(:session_token).where(token_hash: token_hash, )
          SessionToken.eager_load(:account).find_by!(id: id, token_hash: token_hash)&.account
        else 
          nil
        end
      rescue => e
        puts "Error finding acount #{e}"
        puts "Cookie #{cookie}"
        nil
      end
    end
  end
end
